## talloc 2.3.3

=== wscript ===
#!/usr/bin/env python

APPNAME = 'talloc'
VERSION = '2.3.3'

import os
import sys

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Logs, Options, Context

# setup what directories to put in a tarball
samba_dist.DIST_DIRS("""lib/talloc:. lib/replace:lib/replace
buildtools:buildtools third_party/waf:third_party/waf""")


def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('talloc', noextension='talloc')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--enable-talloc-compat1',
                       help=("Build talloc 1.x.x compat library [False]"),
                       action="store_true", dest='TALLOC_COMPAT1', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()

    conf.define('TALLOC_BUILD_VERSION_MAJOR', int(VERSION.split('.')[0]))
    conf.define('TALLOC_BUILD_VERSION_MINOR', int(VERSION.split('.')[1]))
    conf.define('TALLOC_BUILD_VERSION_RELEASE', int(VERSION.split('.')[2]))

    conf.env.TALLOC_COMPAT1 = False
    if conf.env.standalone_talloc:
        conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1
        conf.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        conf.env.TALLOC_VERSION = VERSION

    conf.CHECK_XSLTPROC_MANPAGES()

    conf.CHECK_HEADERS('sys/auxv.h')
    conf.CHECK_FUNCS('getauxval')

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    if not conf.env.standalone_talloc:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('talloc', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TALLOC', 1)

        if conf.env.disable_python:
            using_system_pytalloc_util = False
        else:
            using_system_pytalloc_util = True
            name = 'pytalloc-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(name, minversion=VERSION,
                                                 implied_deps='talloc replace'):
                using_system_pytalloc_util = False

        if using_system_pytalloc_util:
            conf.define('USING_SYSTEM_PYTALLOC_UTIL', 1)


def build(bld):
    bld.RECURSE('lib/replace')

    if bld.env.standalone_talloc:
        private_library = False

        # should we also install the symlink to libtalloc1.so here?
        bld.SAMBA_LIBRARY('talloc-compat1-%s' % (VERSION),
                          'compat/talloc_compat1.c',
                          public_deps='talloc',
                          soname='libtalloc.so.1',
                          pc_files=[],
                          public_headers=[],
                          enabled=bld.env.TALLOC_COMPAT1)

        testsuite_deps = 'talloc'
        if bld.CONFIG_SET('HAVE_PTHREAD'):
            testsuite_deps += ' pthread'

        bld.SAMBA_BINARY('talloc_testsuite',
                         'testsuite_main.c testsuite.c',
                         testsuite_deps,
                         install=False)

        bld.SAMBA_BINARY('talloc_test_magic_differs_helper',
                         'test_magic_differs_helper.c',
                         'talloc', install=False)

    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TALLOC'):

        bld.SAMBA_LIBRARY('talloc',
                          'talloc.c',
                          deps='replace',
                          abi_directory='ABI',
                          abi_match='talloc* _talloc*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers=('' if private_library else 'talloc.h'),
                          pc_files='talloc.pc',
                          public_headers_install=not private_library,
                          private_library=private_library,
                          manpages='man/talloc.3')

    if not bld.CONFIG_SET('USING_SYSTEM_PYTALLOC_UTIL'):
        name = bld.pyembed_libname('pytalloc-util')

        bld.SAMBA_LIBRARY(name,
                source='pytalloc_util.c',
                public_deps='talloc',
                pyembed=True,
                vnum=VERSION,
                hide_symbols=True,
                abi_directory='ABI',
                abi_match='pytalloc_* _pytalloc_*',
                private_library=private_library,
                public_headers=('' if private_library else 'pytalloc.h'),
                pc_files='pytalloc-util.pc',
                enabled=bld.PYTHON_BUILD_IS_ENABLED()
                )
        bld.SAMBA_PYTHON('pytalloc',
                         'pytalloc.c',
                         deps='talloc ' + name,
                         enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                         realname='talloc.so')

        bld.SAMBA_PYTHON('test_pytalloc',
                         'test_pytalloc.c',
                         deps=name,
                         enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                         realname='_test_pytalloc.so',
                         install=False)


def testonly(ctx):
    '''run talloc testsuite'''
    import samba_utils

    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared')
    samba_utils.ADD_LD_LIBRARY_PATH('bin/shared/private')

    cmd = os.path.join(Context.g_module.out, 'talloc_testsuite')
    ret = samba_utils.RUN_COMMAND(cmd)
    print("testsuite returned %d" % ret)
    magic_helper_cmd = os.path.join(Context.g_module.out, 'talloc_test_magic_differs_helper')
    magic_cmd = os.path.join(Context.g_module.top, 'lib', 'talloc',
                             'test_magic_differs.sh')
    if not os.path.exists(magic_cmd):
        magic_cmd = os.path.join(Context.g_module.top, 'test_magic_differs.sh')

    magic_ret = samba_utils.RUN_COMMAND(magic_cmd + " " +  magic_helper_cmd)
    print("magic differs test returned %d" % magic_ret)
    pyret = samba_utils.RUN_PYTHON_TESTS(['test_pytalloc.py'])
    print("python testsuite returned %d" % pyret)
    sys.exit(ret or magic_ret or pyret)

# WAF doesn't build the unit tests for this, maybe because they don't link with talloc?
# This forces it
def test(ctx):
    Options.commands.append('build')
    Options.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    samba_utils.reconfigure(ctx)


def pydoctor(ctx):
    '''build python apidocs'''
    cmd='PYTHONPATH=bin/python pydoctor --project-name=talloc --project-url=http://talloc.samba.org/ --make-html --docformat=restructuredtext --introspect-c-modules --add-module bin/python/talloc.*'
    print("Running: %s" % cmd)
    os.system(cmd)

=== debian/changelog ===
talloc (2.3.3-3~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 04 May 2022 18:43:51 +0300

talloc (2.3.3-3) unstable; urgency=medium

  * d/rules include buildflags.mk instead of open-coding CFLAGS etc definitions
  * d/rules: remove _PUBLIC_ markers from public header file
    fixing samba-4.16 ftbfs
  * d/rules: clean up bin/ not build/
  * d/control: add myself to Uploaders

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 26 Mar 2022 19:11:12 +0300

talloc (2.3.3-2) unstable; urgency=medium

  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * CI: Allow failures for te bhlc job
  * Add 0001-Add-support-for-GNU-kFreeBSD.patch (Closes: #990878)

 -- Mathieu Parent <sathieu@debian.org>  Tue, 14 Dec 2021 20:39:55 +0100

talloc (2.3.3-1) unstable; urgency=medium

  * New upstream version 2.3.3
    - Update symbols
  * Fix lintian override
  * Standards-Version: 4.6.0, no change

 -- Mathieu Parent <sathieu@debian.org>  Tue, 09 Nov 2021 22:06:44 +0100

=== debian/control ===
Source: talloc
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://talloc.samba.org/
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               libpopt-dev,
               python3-dev,
               xsltproc
Rules-Requires-Root: no
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/samba-team/talloc
Vcs-Git: https://salsa.debian.org/samba-team/talloc.git

Package: libtalloc2
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: python3-talloc (<< 2.1.13-2~)
Section: libs
Description: hierarchical pool based memory allocator
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.

Package: libtalloc-dev
Section: libdevel
Depends: libtalloc2 (=${binary:Version}), pkg-config, ${misc:Depends}
Architecture: any
Multi-Arch: same
Description: hierarchical pool based memory allocator - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files.

Package: python3-talloc
Multi-Arch: same
Section: python
Architecture: any
Depends: libtalloc2 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: hierarchical pool based memory allocator - Python3 bindings
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the Python 3 bindings.

Package: python3-talloc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: pkg-config, python3-talloc (= ${binary:Version}), ${misc:Depends}
Description: talloc Python 3 bindings - development files
 A hierarchical pool based memory allocator with destructors. It uses
 reference counting to determine when memory should be freed.
 .
 This package contains the development files for the Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

CFLAGS += -g -Wall

DESTDIR=$(CURDIR)/debian/tmp

conf_args = --prefix=/usr --disable-rpath-install --disable-rpath --bundled-libraries=NONE
conf_args += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
conf_args += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
conf_args += -v

%:
	dh $@ --with python3

override_dh_auto_configure:
	LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" ./configure $(conf_args)

override_dh_auto_build:
	$(MAKE) all V=1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=bin/shared ./bin/talloc_testsuite
endif

override_dh_install:
	DEB_PY3_INCDIR=$(shell python3-config --includes | sed 's,^-I\([^ ]*\).*,\1,') \
		dh_install

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf bin
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8854
	rm -f .lock-wscript
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8855
	rm -rf buildtools/wafsamba/__pycache__ \
	       third_party/waf/waflib/__pycache__/ \
	       third_party/waf/waflib/extras/__pycache__/ \
	       third_party/waf/waflib/Tools/__pycache__/

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)
	# Waf really should be doing this:
	ar -rc libtalloc.a bin/default/talloc*.o
	mv libtalloc.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	#HACK alert: fix up wrong markers in the common include file
	sed -i 's/^_PUBLIC_ //' ${DESTDIR}/usr/include/talloc.h
	touch --reference=talloc.h ${DESTDIR}/usr/include/talloc.h

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -plibtalloc2 -- -c4
	DEB_PY3_EXTENSION_SUFFIX=$(shell python3-config --extension-suffix | tr '_' '-') \
	  DEB_PY3_EXTENSION_UPCASE=$(shell python3-config --extension-suffix | sed 's/\.so$$//' | tr 'a-z-' 'A-Z_') \
	  debian/python3-talloc.symbols.in > debian/python3-talloc.symbols
	dh_makeshlibs -ppython3-talloc -Xtalloc. -- -c3
	rm debian/python3-talloc.symbols

## talloc 2.3.4

=== debian/changelog ===
talloc (2.3.4-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 03 Nov 2022 08:07:47 +0300

talloc (2.3.4-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Update lintian override info to new format on line 3.
  * Update standards version to 4.6.1, no changes needed.

  [ Michael Tokarev ]
  * d/rules: inline parallel check from dpkg/buildopts.mk
  * d/rules: make it to be consistent with other samba packages

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 30 Oct 2022 11:48:34 +0300

talloc (2.3.4-1) unstable; urgency=medium

  * new upstream release (2.3.4)
  * removed 0001-Add-support-for-GNU-kFreeBSD.patch (included upstream now)
  * d/libtalloc2.symbols: add new version

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 05 Sep 2022 12:52:40 +0300

talloc (2.3.3-4) unstable; urgency=medium

  * python3-talloc-dev: move pytalloc.h from python-version-specific dir back
    to /usr/include where upstream installs it
  * remove _PUBLIC_ marking from pytalloc.h header too, not only talloc.h
  * remove whole _PUBLIC_ define from the common installed header
    (do not pollute the namespace and do not clash with other usages)
  * generate header of python3-talloc.symbols file directly from d/rules file
    (it is highly python-dependent, this way it is more visible in one place)
  * d/control: remove build-dependency on dh-exec (used only for .symbols file)
  * set SHELL = sh -e for proper error checking
  * switch from --with python to dh-sequence-python3
  * many other cleanups/tweaks in the d/rules file
  * d/rules: explicitly list targets which go to debhelper
  * d/python3-talloc.lintian-overrides: fix to cover all arches not jut x64
  * d/source/lintian.overrides: add override for buildtools/examples/

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 04 May 2022 18:28:58 +0300

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,14 @@
            Michael Tokarev <mjt@tls.msk.ru>
 Homepage: https://talloc.samba.org/
 Build-Depends: debhelper-compat (= 13),
-               dh-exec,
-               dh-python,
+               dh-sequence-python3,
                docbook-xml,
                docbook-xsl,
                libpopt-dev,
                python3-dev,
                xsltproc
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/samba-team/talloc
 Vcs-Git: https://salsa.debian.org/samba-team/talloc.git

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -g -Wall
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/buildflags.mk
V = 1
WAF = PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(if $(filter parallel=%,${DEB_BUILD_OPTIONS}),\
	  $(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS})))

DESTDIR = ${CURDIR}/debian/tmp

build-arch build-indep build \
install-indep install-arch install \
binary-arch binary-indep binary \
: %:
	dh $@

override_dh_auto_configure: bin/config-stamp
bin/config-stamp:
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	    ${WAF} -j1 -C configure \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
		--disable-rpath --disable-rpath-install \
		--bundled-libraries=NONE \
	    && touch $@

override_dh_auto_build: bin/config-stamp
	${WAF} build $(if $V,-v)
	# Waf should be doing this..
	ar rc bin/libtalloc.a bin/default/talloc*.o

override_dh_auto_test:
ifeq (,$(filter nocheck,${DEB_BUILD_OPTIONS}))
	LD_LIBRARY_PATH=bin/shared ./bin/talloc_testsuite
endif

override_dh_auto_install:
	${WAF} install --destdir=${DESTDIR}
	cp bin/libtalloc.a ${DESTDIR}/usr/lib/${DEB_HOST_MULTIARCH}/
	#HACK alert: fix up wrong markers in the common include file
	sed -i 's/^_PUBLIC_ //' \
		${DESTDIR}/usr/include/talloc.h \
		${DESTDIR}/usr/include/pytalloc.h
	# ..and remove the #define itself
	patch --batch ${DESTDIR}/usr/include/talloc.h debian/header-remove-_PUBLIC_-define.patch

override_dh_makeshlibs:
	dh_makeshlibs -plibtalloc2 -- -c4
	{ \
	    debver=$$(dpkg-parsechangelog -SVersion | sed 's/-.*//'); \
	    suff=$$(python3-config --extension-suffix | tr _ -); \
	    SUFF=$$(echo "$${suff%.so}" | tr a-z- A-Z_)_$${debver}; \
	    echo "libpytalloc-util$${suff}.2 python3-talloc #MINVER#"; \
	    echo " PYTALLOC_UTIL$${SUFF}@PYTALLOC_UTIL$${SUFF} $${debver}"; \
	    cat debian/python3-talloc.symbols.in; \
	} > debian/python3-talloc.symbols
	dh_makeshlibs -ppython3-talloc -X/talloc.cpython -- -c3
	rm debian/python3-talloc.symbols

clean:
	# see also debian/clean
	dh_clean bin/

get-packaged-orig-source:
	./debian/build-orig.sh

## talloc 2.4.0

=== debian/changelog ===
talloc (2.4.0-f2A~5.0.0.202304171133) ucs5-0-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    01_build-depends
    02_python37

 -- Univention builddaemon <buildd@univention.de>  Mon, 17 Apr 2023 11:33:57 +0200

talloc (2.4.0-f2) unstable; urgency=medium

  * d/rules: build for all installed py3versions
    instead of default/supported
  * d/control: remove unused ${python3:Provides}
  * d/control: Standards-Version: 4.6.2 (no changes)
  * d/control: put all doc-generating build-deps into one line
  * little prep for cross-compilation
  * d/control: work around autodep8 #904999 again

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 04 Feb 2023 17:10:46 +0300

talloc (2.4.0-f1) unstable; urgency=medium

  * new upstream release (2.4.0, samba 4.18):
   - Add talloc_asprintf_addbuf()
   - Support python 3.12
  * d/libtalloc2.symbols: add new symbol and new versions
  * d/python3-talloc.symbols.in: add new versions

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 21 Jan 2023 10:38:53 +0300

talloc (2.3.4-3) unstable; urgency=medium

  * Allow building for multiple python3 versions (disabled for now)
  * d/rules: support "terse" build option for non-verbose build
  * lintian-overrides: update some messages to match old&new lintian
  * d/tests: remove. The autopkgtest just run the build-time testsuite,
    which is already done at build time (dh_auto_test).
  * d/salsa-ci.yml:
   - instead of allowing blhc to (always) fail, disable it
   - disable crossbuild-arm64 test (samba does not cross-build)
  * d/rules: little cleanups

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 20 Jan 2023 17:40:38 +0300

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,14 @@
            Mathieu Parent <sathieu@debian.org>,
            Michael Tokarev <mjt@tls.msk.ru>
 Homepage: https://talloc.samba.org/
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 12),
                dh-sequence-python3,
-               docbook-xml,
-               docbook-xsl,
+               docbook-xml, docbook-xsl, xsltproc,
                libpopt-dev,
-               python3-dev,
-               xsltproc
+# use {python3,libpython3}-ALL-dev to build for all python3 versions (+#904999):
+               python3-dev:any | python3-dev, libpython3-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/samba-team/talloc
 Vcs-Git: https://salsa.debian.org/samba-team/talloc.git
 
@@ -48,7 +47,6 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Provides: ${python3:Provides}
 Description: hierarchical pool based memory allocator - Python3 bindings
  A hierarchical pool based memory allocator with destructors. It uses
  reference counting to determine when memory should be freed.

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -g -Wall
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

ifeq (linux,${DEB_HOST_ARCH_OS})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata_m_${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif

# All supported installed python versions we build for
export PY3VERSIONS := $(or ${PY3VERSIONS}, $(shell py3versions -i))

DESTDIR := ${CURDIR}/debian/tmp

build-arch build-indep build \
install-arch install-indep install \
binary-arch binary-indep binary \
: %:
	dh $@

# Build in bld/pyNN/ subdirs (named after python version),
# Since wafsamba can't build things in a named subdir,
# we have to copy (link) whole source dir into each build subdir.

.NOTPARALLEL: # don't run commands at this level in parallel

py-targets = $(patsubst %, bld/%/$(strip $1), ${PY3VERSIONS})

override_dh_auto_configure: $(call py-targets, stamp-config)
$(call py-targets, stamp-config): %/stamp-config:
	@echo "=== running configure in $* ==="
	mkdir -p $*
	cp -al $$(ls -1 | egrep -v '^(bld|debian)$$') $*
	cd $*; \
	    CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	    CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	    PYTHON=$(notdir $*) PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-$(notdir $*)-config \
	    ${WAF} -j1 -C configure \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
		--disable-rpath --disable-rpath-install \
		--bundled-libraries=NONE \

	touch $@

override_dh_auto_build: $(call py-targets, stamp-build)
$(call py-targets, stamp-build): %/stamp-build: %/stamp-config
	@echo "=== running build in $* ==="
	cd $*; ${WAF} $(if $V,-v) build
	# Waf should be doing this..
	ar rc $*/bin/libtalloc.a $*/bin/default/talloc*.o

# the testsuite does not test python bindings so there's no reason to test all pyversions
override_dh_auto_test: \
  $(if $(filter nocheck,${DEB_BUILD_OPTIONS}), , $(firstword $(call py-targets, test)))
$(call py-targets, test): %/test: %/stamp-build
	echo "=== running test in $* ==="
	cd $*; LD_LIBRARY_PATH=bin/shared ./bin/talloc_testsuite

$(call py-targets, install): %/install: %/stamp-build
	@echo "=== running install in $* ==="
	cd $*; ${WAF} install --destdir=${DESTDIR}
	cp $*/bin/libtalloc.a ${DESTDIR}/usr/lib/${DEB_HOST_MULTIARCH}/
override_dh_auto_install: $(call py-targets, install)
	#HACK alert: fix up wrong markers in the common include file
	sed -i 's/^_PUBLIC_ //' \
		${DESTDIR}/usr/include/talloc.h \
		${DESTDIR}/usr/include/pytalloc.h
	# ..and remove the #define itself
	patch --batch ${DESTDIR}/usr/include/talloc.h debian/header-remove-_PUBLIC_-define.patch

override_dh_makeshlibs:
	dh_makeshlibs -plibtalloc2 -- -c4
	for pv in ${PY3VERSIONS}; do \
	    suff=$$(${DEB_HOST_MULTIARCH}-$$pv-config --extension-suffix | tr _ -); \
	    SUFF=$$(echo "$${suff%.so}" | tr a-z- A-Z_)_${DEB_VERSION_UPSTREAM}; \
	    echo "libpytalloc-util$${suff}.2 python3-talloc #MINVER#"; \
	    echo " PYTALLOC_UTIL$${SUFF}@PYTALLOC_UTIL$${SUFF} ${DEB_VERSION_UPSTREAM}"; \
	    cat debian/python3-talloc.symbols.in; \
	done > debian/python3-talloc.symbols
	dh_makeshlibs -ppython3-talloc -X/talloc.cpython -- -c3
	rm debian/python3-talloc.symbols

clean:
	dh_clean bld/

get-packaged-orig-source:
	./debian/build-orig.sh

## talloc 2.4.1

=== debian/changelog ===
talloc (2.4.1-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 06 Oct 2023 17:45:01 +0300

talloc (2.4.1-2) unstable; urgency=medium

  * d/rules: wrap _PYTHON_SYSCONFIGDATA_NAME setting to cross-compile case
    On e.g. buster, _PYTHON_SYSCONFIGDATA_NAME is different, so this assignment
    does not work right.  In order for it to work on buster, add condition on
    host vs build gnu type. This breaks compilation with foreign python binary.

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 04 Aug 2023 14:15:17 +0300

talloc (2.4.1-1) unstable; urgency=medium

  * new upstream release.

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 30 Jul 2023 22:39:02 +0300

## talloc 2.4.2

=== debian/changelog ===
talloc (2.4.2-2) unstable; urgency=medium

  * d/control: Build-Depend on python3-setuptools (Closes: #1080815)
  * d/control: drop before-buster Breaks
  * d/control: drop pkg-config dependency for libtalloc-dev
    the dev package does not depend on pkg-config itself, it is the users
    who choose to use it through pkg-config
  * stop providing python3-talloc-dev package, swallow it by python3-talloc
    the development files (pytalloc.h, pytalloc-util.cpython.so and .pc)
    are not worth to provide its own package for.
  * stop providing symbols for internal pytalloc_util library
    This library is internal, which also depends on python arch
    and version.  The set of symbols in this library is stable.
    Stop jumping through hoops trying to provide accurate symbols
    file, treat it like a simplest shared library

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 25 Nov 2024 11:29:13 +0300

talloc (2.4.2-1) unstable; urgency=medium

  * new upstream (minor) release

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 29 Jan 2024 20:14:03 +0300

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,9 @@
            Mathieu Parent <sathieu@debian.org>,
            Michael Tokarev <mjt@tls.msk.ru>
 Homepage: https://talloc.samba.org/
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               python3-setuptools,
                docbook-xml, docbook-xsl, xsltproc,
                libpopt-dev,
 # use {python3,libpython3}-ALL-dev to build for all python3 versions (+#904999):
@@ -22,7 +23,6 @@
 Pre-Depends: ${misc:Pre-Depends}
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: python3-talloc (<< 2.1.13-2~)
 Section: libs
 Description: hierarchical pool based memory allocator
  A hierarchical pool based memory allocator with destructors. It uses
@@ -30,7 +30,7 @@
 
 Package: libtalloc-dev
 Section: libdevel
-Depends: libtalloc2 (=${binary:Version}), pkg-config, ${misc:Depends}
+Depends: libtalloc2 (=${binary:Version}), ${misc:Depends}
 Architecture: any
 Multi-Arch: same
 Description: hierarchical pool based memory allocator - development files
@@ -47,19 +47,12 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
+# Swallow python3-talloc-dev package in 2.4.2-2
+Provides: python3-talloc-dev (= ${binary:Version})
+Replaces: python3-talloc-dev (<<2.4.2-2~)
+Breaks:   python3-talloc-dev (<<2.4.2-2~)
 Description: hierarchical pool based memory allocator - Python3 bindings
  A hierarchical pool based memory allocator with destructors. It uses
  reference counting to determine when memory should be freed.
  .
  This package contains the Python 3 bindings.
-
-Package: python3-talloc-dev
-Architecture: any
-Multi-Arch: same
-Section: libdevel
-Depends: pkg-config, python3-talloc (= ${binary:Version}), ${misc:Depends}
-Description: talloc Python 3 bindings - development files
- A hierarchical pool based memory allocator with destructors. It uses
- reference counting to determine when memory should be freed.
- .
- This package contains the development files for the Python 3 bindings.

=== debian/rules ===
--- 
+++ 
@@ -17,8 +17,10 @@
 	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))
 
 ifeq (linux,${DEB_HOST_ARCH_OS})
+ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
 # for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
-export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata_m_${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
+export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
+endif
 endif
 
 # All supported installed python versions we build for
@@ -83,18 +85,6 @@
 	# ..and remove the #define itself
 	patch --batch ${DESTDIR}/usr/include/talloc.h debian/header-remove-_PUBLIC_-define.patch
 
-override_dh_makeshlibs:
-	dh_makeshlibs -plibtalloc2 -- -c4
-	for pv in ${PY3VERSIONS}; do \
-	    suff=$$(${DEB_HOST_MULTIARCH}-$$pv-config --extension-suffix | tr _ -); \
-	    SUFF=$$(echo "$${suff%.so}" | tr a-z- A-Z_)_${DEB_VERSION_UPSTREAM}; \
-	    echo "libpytalloc-util$${suff}.2 python3-talloc #MINVER#"; \
-	    echo " PYTALLOC_UTIL$${SUFF}@PYTALLOC_UTIL$${SUFF} ${DEB_VERSION_UPSTREAM}"; \
-	    cat debian/python3-talloc.symbols.in; \
-	done > debian/python3-talloc.symbols
-	dh_makeshlibs -ppython3-talloc -X/talloc.cpython -- -c3
-	rm debian/python3-talloc.symbols
-
 clean:
 	dh_clean bld/
